<?php

class LoginController extends Zend_Controller_Action
{
    public function indexAction()
    {
    	
    	$this->view->title = "Logowanie";
    	$this->view->breadCrumb = $this->view->title;
    	$this->view->whiteContent = true;
    	
        $auth = Zend_Auth::getInstance();
        if($auth->hasIdentity())
        {
            $this->getHelper( 'Redirector' )->gotoUrl('/admin/');
        }

        $request = $this->getRequest();
        if($request->isPost())
        {
             
            $username = $request->getParam('username',false);
            $password = $request->getParam('password', false);
             
            if($username && $password)
            {
                // Bierzemy AuthAdapter i sprawdzamy czy zostaliśmy autoryzowani
                $authAdapter = new Zend_Auth_Adapter_DbTable( Zend_Db_Table::getDefaultAdapter() );
                $authAdapter
                ->setTableName( 'user' )
                ->setIdentityColumn( 'username' )
                ->setCredentialColumn( 'password' )
                ;

                $authAdapter
                ->setIdentity( $username)
                ->setCredential( hash( 'md5', $password) );


                // Wykonujemy autoryzacje, zapisujemy wynik
                $result = $auth->authenticate( $authAdapter );
                if ($result->isValid() ) {

                    $this->getHelper( 'Redirector' )->gotoUrl('/admin' );
                }
                else
                {
                    $this->view->error = 'Błąd logowania';
                }
            }
            else
            {
                $this->view->error = 'Błąd logowania';
            }
             
             
        }
    }

    public function logoutAction()
    {
        Zend_Auth::getInstance()->clearIdentity();
        $this->getHelper( 'Redirector' )->gotoUrl('/admin' );
    }

     



}

