<?php 
class Application_Form_Partner extends Zend_Form
{
    public function init()
    {
        $partnerTypeMapper = new Application_Model_PartnerTypeMapper();
        $partnerTypes = $partnerTypeMapper->fetchAll();
        // Set the method for the display form to POST
        $this->setMethod('post');
        $this->setEnctype(Zend_Form::ENCTYPE_MULTIPART);
        
 
        // Add an email element
        
        $this->addElement('checkbox', 'active', array(
            'label'      => 'Aktywny:',
            'required'   => true,
        ));
        
        $partnerTypeSelect = new Zend_Form_Element_Select('partnerType', array(
            'label'      => 'Typ partnera:',
            'required'   => true,
        	'validators' => array(
             array( 'NotEmpty', true, array(
                    'messages' => array(
                       'isEmpty' => 'Pole nie może by puste.'
                 ))),
             )
        ));
        
        foreach($partnerTypes as $partnerType)
            $partnerTypeSelect->addMultiOption($partnerType->getId(), $partnerType->getName());
        
        $this->addElement($partnerTypeSelect);
             
        $image = new Zend_Form_Element_File('image');
        $image->setLabel('Obrazek:')
              ->setDestination(realpath(APPLICATION_PATH . '/../public/uploads'))
              ->setRequired(false)
              ->setMaxFileSize(2097152); // limits the filesize on the client side
        $image->addValidator('Count', false, 1);                // ensure only 1 file
        $image->addValidator('Size', false, 2097152);            // limit to 10 meg
        $image->addValidator('Extension', false, 'jpg,jpeg,png,gif');// only JPEG, PNG, and GIFs
        $this->addElement($image);

        
        $this->addElement('text', 'link', array(
            'label'      => 'Link:',
            'required'   => false,
        ));
 
        // Add the submit button
        $this->addElement('submit', 'submit', array(
            'ignore'   => true,
            'label'    => 'Zatwierdź',
        ));
 
    }
}