<?php 
class Application_Form_Vote extends Zend_Form
{
    public function init()
    {
        $voteMapper = new Application_Model_VoteMapper();
        $votes = $voteMapper->fetchAllActive();
        // Set the method for the display form to POST
        $this->setMethod('post');
        $this->setEnctype(Zend_Form::ENCTYPE_MULTIPART);
        $this->setDisableLoadDefaultDecorators(true);
        
         $this->addDecorator('FormElements')
             ->addDecorator('HtmlTag') 
             ->addDecorator('Form');
        
        $page = new Application_Model_Page();
        $pageMapper = new Application_Model_PageMapper();
        // Add an email element
        
        foreach($votes as $vote)
        {
            $pageMapper->find($vote->getPage(), $page);
            
            $voteRadio = new Zend_Form_Element_Radio('voteRadio'.$vote->getId(), array(
                'label'      => $page->getTitle(),
                'required'   => false,
          
            ));
            $voteRadio->setSeparator('&nbsp;');
        
            $voteRadio->addMultiOption('1','1');
            $voteRadio->addMultiOption('2','2');
            $voteRadio->addMultiOption('3','3');
            $voteRadio->addMultiOption('4','4');
            $voteRadio->addMultiOption('5','5');
            if(isset($_COOKIE['voteRadio'.$vote->getId()]) && $_COOKIE['voteRadio'.$vote->getId()] == '1')
                $voteRadio->setAttrib('disabled', true);
            
           
        
        $this->addElement($voteRadio);
        

        $this->addDisplayGroup(array('voteRadio'.$vote->getId()), 'voteRadioa'.$vote->getId());
        
        $group = $this->getDisplayGroup ('voteRadioa'.$vote->getId());
        $group->removeDecorator ('Zend_Form_Decorator_DtDdWrapper');
        
        
        }
             
 
        // Add the submit button
        $this->addElement('submit', 'submit', array(
            'ignore'   => true,
            'label'    => 'Zatwierdź',
        ));
        
        
 
    }
}