<?php 
class Application_Form_VoteAdmin extends Zend_Form
{
    public function init()
    {
        $pageMapper = new Application_Model_PageMapper();
        $pages = $pageMapper->fetchAllToVote();
        // Set the method for the display form to POST
        $this->setMethod('post');
        $this->setEnctype(Zend_Form::ENCTYPE_MULTIPART);
        
 
        // Add an email element
        
        $this->addElement('checkbox', 'active', array(
            'label'      => 'Aktywny:',
            'required'   => true,
        ));
        
        $pageSelect = new Zend_Form_Element_Select('page', array(
            'label'      => 'Film:',
            'required'   => true,
        	'validators' => array(
             array( 'NotEmpty', true, array(
                    'messages' => array(
                       'isEmpty' => 'Pole nie może by puste.'
                 ))),
             )
        ));
        
        foreach($pages as $page)
            $pageSelect->addMultiOption($page->getId(), $page->getTitle());
        
        $this->addElement($pageSelect);
             
 
        // Add the submit button
        $this->addElement('submit', 'submit', array(
            'ignore'   => true,
            'label'    => 'Zatwierdź',
        ));
 
    }
}