<?php

 
class Application_Model_DictionaryBackground
{
	protected $_id;
	protected $_dictionaryId;
	protected $_type;
	protected $_title;
	protected $_lead;
	protected $_image;
    protected $_description;
  
    public function __construct(array $options = null)
    {
        if (is_array($options)) {
            $this->setOptions($options);
        }
    }
 
    public function __set($name, $value)
    {
        $method = 'set' . $name;
        if (('mapper' == $name) || !method_exists($this, $method)) {
            throw new Exception('Invalid page property');
        }
        $this->$method($value);
    }
 
    public function __get($name)
    {
        $method = 'get' . $name;
        if (('mapper' == $name) || !method_exists($this, $method)) {
            throw new Exception('Invalid page property');
        }
        return $this->$method();
    }
 
    public function setOptions(array $options)
    {
        $methods = get_class_methods($this);
        foreach ($options as $key => $value) {
            $method = 'set' . ucfirst($key);
            if (in_array($method, $methods)) {
                $this->$method($value);
            }
        }
        return $this;
    }
    
    public function getOptions()
    {
        $vars = get_class_vars('Application_Model_Dictionary');
        $data = array();
        foreach ($vars as $key => $value) {
           $data[ltrim($key,'_')] = $this->$key;
        }
       
        return $data;
    }

    public function setDictionaryId($dictionaryId)
    {
    	$this->_dictionaryId = $dictionaryId;
    	return $this;
    }
    
    public function getDictionaryId()
    {
    	return $this->_dictionaryId;
    }
    
    public function setType($type)
    {
    	$this->_type = (int) $type;
    	return $this;
    }
    
    public function getType()
    {
    	return $this->_type;
    }
    
    public function setTitle($title)
    {
    	$this->_title = (string) $title;
    	return $this;
    }
    
    public function getTitle()
    {
    	return $this->_title;
    }
    
    public function setLead($txt)
    {
    	$this->_lead = (string) $txt;
    	return $this;
    }
    
    public function getLead()
    {
    	return $this->_lead;
    }
   
    
    public function setImage($txt)
    {
    	$this->_image = (string) $txt;
    	return $this;
    }
    
    public function getImage()
    {
    	return $this->_image;
    }
    
    
    
    public function setDescription($txt)
    {
    	$this->_description = (string) $txt;
    	return $this;
    }
    
    public function getDescription()
    {
    	return $this->_description;
    }
     
    public function setId($id)
    {
        $this->_id = (int) $id;
        return $this;
    }
 
    public function getId()
    {
        return $this->_id;
    }
}