<?php
class Application_Model_DictionaryBackgroundMapper
{
	protected $_dbTable;
	
	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}

	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('Application_Model_DbTable_DictionaryBackground');
		}
		return $this->_dbTable;
	}

	
	public function save(Application_Model_DictionaryBackground $dictionaryBackground)
	{
		$data = array(
            'dictionary_id' => $dictionaryBackground->dictionaryId,
			'type' => $dictionaryBackground->type,
            'title' => $dictionaryBackground->title,
			'lead' => $dictionaryBackground->lead,
			'image' => $dictionaryBackground->image,
			'description' => 	$dictionaryBackground->description,
		);

		if (null === ($id =  $dictionaryBackground->id )) {
			unset($data['id']);
			return $this->getDbTable()->insert($data);
		} else {
			return $this->getDbTable()->update($data, array('id = ?' => $id));
		}
	}
	
    public function delete($dictionaryBackgroundId=false,$dictionaryId=false)
	{
		if($dictionaryBackgroundId)
			return $this->getDbTable()->delete('id = '.$dictionaryBackgroundId);
		else if($dictionaryId)
			return $this->getDbTable()->delete('dictionary_id = '.$dictionaryId);
	}

	public function find($id, Application_Model_DictionaryBackground $dictionaryBackground)
	{
		$result = $this->getDbTable()->find($id);
		if (0 == count($result)) {
			return false;
		}
		$row = $result->current();
		
		$dictionaryBackground->id = $row->id;
		$dictionaryBackground->dictionaryId = $row->dictionary_id;
		$dictionaryBackground->type = $row->type;
        $dictionaryBackground->title = $row->title;
        $dictionaryBackground->lead = $row->lead;
		$dictionaryBackground->image = $row->image;
		$dictionaryBackground->description = $row->description;
			
		return true;
	}
	
	public function fetchAll($type=false, $dictionaryId=false)
	{
	    $select = $this->getDbTable()->select()
	   ->order('id asc');
	    if($type)
	    	$select->where('type = ?', $type);
	    if($dictionaryId)
	   	 	$select->where('dictionary_id = ?', $dictionaryId);
	    	
	    $resultSet = $this->getDbTable()->fetchAll($select);
		$entries   = array();
		foreach ($resultSet as $row) {
			$dictionaryBackground = new Application_Model_DictionaryBackground();
			
			$dictionaryBackground->id = $row->id;
			$dictionaryBackground->dictionaryId = $row->dictionary_id;
			$dictionaryBackground->type = $row->type;
	        $dictionaryBackground->title = $row->title;
	        $dictionaryBackground->lead = $row->lead;
			$dictionaryBackground->image = $row->image;
			$dictionaryBackground->description = $row->description;
		
			$entries[] = $dictionaryBackground;
		}
		return $entries;
	}
}
