<?php
class Application_Model_DictionaryTypeMapper
{
	protected $_dbTable;
	
	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}

	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('Application_Model_DbTable_DictionaryType');
		}
		return $this->_dbTable;
	}

	
	public function save(Application_Model_DictionaryType $dictionaryType)
	{
		$data = array(
            'title' => $dictionaryType->title,
            'img' => $dictionaryType->img
		);

		if (null === ($id =  $dictionaryType->id())) {
			unset($data['id']);
			return $this->getDbTable()->insert($data);
		} else {
			return $this->getDbTable()->update($data, array('id = ?' => $id));
		}
	}
	
    public function delete($dictionaryTypeId)
	{
		return $this->getDbTable()->delete('id = '.$dictionaryTypeId);
	}

	public function find($id, Application_Model_DictionaryType $dictionaryType)
	{
		$result = $this->getDbTable()->find($id);
		if (0 == count($result)) {
			return false;
		}
		$row = $result->current();
		
		$dictionaryType->id = $row->id;
        $dictionaryType->title = $row->title;
        $dictionaryType->img = $row->img;
					
		return true;
	}
	
	public function fetchAll()
	{
	    $select = $this->getDbTable()->select()
	   ->order('id asc');
	    $resultSet = $this->getDbTable()->fetchAll($select);
		$entries   = array();
		foreach ($resultSet as $row) {
			$dictionaryType = new Application_Model_DictionaryType();
			
			$dictionaryType->id = $row->id;
	        $dictionaryType->title = $row->title;
	        $dictionaryType->img = $row->img;
		
			$entries[] = $dictionaryType;
		}
		return $entries;
	}
}
