<?php
class Application_Model_DictionaryVocabularyRangeDictMapper
{
	protected $_dbTable;
	
	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}

	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('Application_Model_DbTable_DictionaryVocabularyRangeDict');
		}
		return $this->_dbTable;
	}

	
	public function save(Application_Model_DictionaryVocabularyRangeDict $dictionaryVocabularyRangeDict)
	{
		$data = array(
            'title' => $dictionaryVocabularyRangeDict->title,
            'class' => $dictionaryVocabularyRangeDict->class,

		);

		if (null === ($id =  $dictionaryVocabularyRangeDict->id())) {
			unset($data['id']);
			return $this->getDbTable()->insert($data);
		} else {
			return $this->getDbTable()->update($data, array('id = ?' => $id));
		}
	}
	
    public function delete($dictionaryVocabularyRangeDictId)
	{
		return $this->getDbTable()->delete('id = '.$dictionaryVocabularyRangeDictId);
	}

	public function find($id, Application_Model_DictionaryVocabularyRangeDict $dictionaryVocabularyRangeDict)
	{
		$result = $this->getDbTable()->find($id);
		if (0 == count($result)) {
			return false;
		}
		$row = $result->current();
		
		$dictionaryVocabularyRangeDict->id = $row->id;
        $dictionaryVocabularyRangeDict->title = $row->title;
        $dictionaryVocabularyRangeDict->class = $row->class;
				
		return true;
	}
	
	public function fetchAll()
	{
	    $select = $this->getDbTable()->select()
	   ->order('id asc');
	    $resultSet = $this->getDbTable()->fetchAll($select);
		$entries   = array();
		foreach ($resultSet as $row) {
			$dictionaryVocabularyRangeDict = new Application_Model_DictionaryVocabularyRangeDict();
			
			$dictionaryVocabularyRangeDict->id = $row->id;
        	$dictionaryVocabularyRangeDict->title = $row->title;
        	$dictionaryVocabularyRangeDict->class = $row->class;
		
		$entries[] = $dictionaryVocabularyRangeDict;
		}
		return $entries;
	}
}
