<?php
class Application_Model_DictionaryVocabularyRangeMapper
{
	protected $_dbTable;
	
	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}

	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('Application_Model_DbTable_DictionaryVocabularyRange');
		}
		return $this->_dbTable;
	}

	
	public function save(Application_Model_DictionaryVocabularyRange $dictionaryVocabularyRange)
	{
		$data = array(
            'dictionary_id' => $dictionaryVocabularyRange->dictionaryId,
            'vocabulary_range_id' => $dictionaryVocabularyRange->vocabularyRangeId,
            

		);

		if (null === ($id =  $dictionaryVocabularyRange->id)) {
			unset($data['id']);
			return $this->getDbTable()->insert($data);
		} else {
			return $this->getDbTable()->update($data, array('id = ?' => $id));
		}
	}
	
    public function delete($dictionaryId)
	{
		return $this->getDbTable()->delete('dictionary_id = '.$dictionaryId);
	}

	public function find($id, Application_Model_DictionaryVocabularyRange $dictionaryVocabularyRange)
	{
		$result = $this->getDbTable()->find($id);
		if (0 == count($result)) {
			return false;
		}
		$row = $result->current();
		
		$dictionaryVocabularyRange->id = $row->id;
		$dictionaryVocabularyRange->dictionaryId = $row->dictionary_id;
        $dictionaryVocabularyRange->vocabularyRangeId = $row->vocabulary_range_id;
        			
		return true;
	}
	
	public function fetchAll($dictionaryId=false)
	{
	    $select = $this->getDbTable()->select()
	   ->order('id asc');
	    if($dictionaryId)
	    	$select->where('dictionary_id = ?', $dictionaryId);
	    $resultSet = $this->getDbTable()->fetchAll($select);
		$entries   = array();
		foreach ($resultSet as $row) {
			$dictionaryVocabularyRange = new Application_Model_DictionaryVocabularyRange();
			
			$dictionaryVocabularyRange->id = $row->id;
			$dictionaryVocabularyRange->dictionaryId = $row->dictionary_id;
        	$dictionaryVocabularyRange->vocabularyRangeId = $row->vocabulary_range_id;
		
			$entries[] = $dictionaryVocabularyRange;
		}
		return $entries;
	}
}
