<?php
class Application_Model_PageTypeMapper
{
	protected $_dbTable;

	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}

	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('Application_Model_DbTable_Gallery');
		}
		return $this->_dbTable;
	}

	public function find($id, Application_Model_PageType $pageType)
	{
		$result = $this->getDbTable()->find($id);
		if (0 == count($result)) {
			return;
		}
		$row = $result->current();
		$pageType->setId($row->id)
		->setName($row->name);
	}
	
	public function fetchAll()
	{
	    $select = $this->getDbTable()->select()
	    ->order('id asc');
	    $resultSet = $this->getDbTable()->fetchAll($select);
		$entries   = array();
		foreach ($resultSet as $row) {
			$entry = new Application_Model_Gallery();
			$entry->setId($row->id)
		    ->setName($row->name)
		    ->setActive($row->active);
			$entries[] = $entry;
		}
		return $entries;
	}
}