<?php

 
class Application_Model_Partner
{
	protected $_id;
	protected $_title;
    protected $_logo;
    protected $_www;
    protected $_active;

    public function __construct(array $options = null)
    {
        if (is_array($options)) {
            $this->setOptions($options);
        }
    }
 
    public function __set($name, $value)
    {
        $method = 'set' . $name;
        if (('mapper' == $name) || !method_exists($this, $method)) {
            throw new Exception('Invalid page property');
        }
        $this->$method($value);
    }
 
    public function __get($name)
    {
        $method = 'get' . $name;
        if (('mapper' == $name) || !method_exists($this, $method)) {
            throw new Exception('Invalid page property');
        }
        return $this->$method();
    }
 
    public function setOptions(array $options)
    {
        $methods = get_class_methods($this);
        foreach ($options as $key => $value) {
            $method = 'set' . ucfirst($key);
            if (in_array($method, $methods)) {
                $this->$method($value);
            }
        }
        return $this;
    }
    
    public function getOptions()
    {
        $vars = get_class_vars('Application_Model_Partner');
        $data = array();
        foreach ($vars as $key => $value) {
           $data[ltrim($key,'_')] = $this->$key;
        }
       
        return $data;
    }
 
    public function setTitle($title)
    {
        $this->_title = $title;
        return $this;
    }
 
    public function getTitle()
    {
        return $this->_title;
    }
 
    public function setLogo($image)
    {
        $this->_logo = (string) $image;
        return $this;
    }
 
    public function getLogo()
    {
        return $this->_logo;
    }
    
    public function setWww($link)
    {
        $this->_www = (string) $link;
        return $this;
    }
 
    public function getWww()
    {
        return $this->_www;
    }
 
    
    public function setActive($active)
    {
        $this->_active = $active;
        return $this;
    }
 
    public function getActive()
    {
        return $this->_active;
    }
    
    
    public function setId($id)
    {
        $this->_id = (int) $id;
        return $this;
    }
 
    public function getId()
    {
        return $this->_id;
    }
}