<?php
class Application_Model_ProductCategoryMapper
{
	protected $_dbTable;

	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}

	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('Application_Model_DbTable_ProductCategory');
		}
		return $this->_dbTable;
	}

	public function find($id, Application_Model_ProductCategory $productCategory)
	{
		$result = $this->getDbTable()->find($id);
		if (0 == count($result)) {
			return;
		}
		$row = $result->current();
		$productCategory->setId($row->id)
		->setName($row->name);
	}
	
	public function fetchAll()
	{
	    $select = $this->getDbTable()->select()
	    ->order('id asc');
	    $resultSet = $this->getDbTable()->fetchAll($select);
		$entries   = array();
		foreach ($resultSet as $row) {
			$entry = new Application_Model_ProductCategory();
			$entry->setId($row->id)
		    ->setName($row->name);
			$entries[] = $entry;
		}
		return $entries;
	}
	
    public function fetchBySlug($slug)
	{
	    $select = $this->getDbTable()->select()
	    ->where('name = ?', str_replace("-", " ", $slug) );
	    $row = $this->getDbTable()->fetchRow($select);
	    if($row)
	    {
    		$entry = new Application_Model_ProductCategory();
    		$entry->setId($row->id)
    	    ->setName($row->name);
    	    
    	    return $entry;
	    }
	    return false;
		
		
	}
}