<?php

 
class Application_Model_ProductPartners
{
	protected $_id;
	protected $_productId;
    protected $_productPartnerId;


    public function __construct(array $options = null)
    {
        if (is_array($options)) {
            $this->setOptions($options);
        }
    }
 
    public function __set($name, $value)
    {
        $method = 'set' . $name;
        if (('mapper' == $name) || !method_exists($this, $method)) {
            throw new Exception('Invalid page property');
        }
        $this->$method($value);
    }
 
    public function __get($name)
    {
        $method = 'get' . $name;
        if (('mapper' == $name) || !method_exists($this, $method)) {
            throw new Exception('Invalid page property');
        }
        return $this->$method();
    }
 
    public function setOptions(array $options)
    {
        $methods = get_class_methods($this);
        foreach ($options as $key => $value) {
            $method = 'set' . ucfirst($key);
            if (in_array($method, $methods)) {
                $this->$method($value);
            }
        }
        return $this;
    }
    
    public function getOptions()
    {
        $vars = get_class_vars('Application_Model_ProductPartner');
        $data = array();
        foreach ($vars as $key => $value) {
           $data[ltrim($key,'_')] = $this->$key;
        }
       
        return $data;
    }
 
    public function setProductId($productId)
    {
    	$this->_productId = $productId ;
    	return $this;
    }
    
    public function getProductId()
    {
    	return $this->_productId;
    }
    
    public function setProductPartnerId($productPartnerId)
    {
    	$this->_productPartnerId = $productPartnerId ;
    	return $this;
    }
    
    public function getproductPartnerId()
    {
    	return $this->_productPartnerId;
    }
    
    public function setId($id)
    {
        $this->_id = (int) $id;
        return $this;
    }
 
    public function getId()
    {
        return $this->_id;
    }
}