<?php
class Application_Model_ProductPartnersMapper
{
	protected $_dbTable;

	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}

	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('Application_Model_DbTable_ProductPartners');
		}
		return $this->_dbTable;
	}

	public function save(Application_Model_ProductPartners $partner)
	{
		$data = array(
			'product_id' => $partner->getProductId(),
			'product_partner_id' => $partner->getproductPartnerId(),

		   
		    
		);

		if (null === ($id = $partner->getId())) {
			unset($data['id']);
			return $this->getDbTable()->insert($data);
		} else {
			return $this->getDbTable()->update($data, array('id = ?' => $id));
		}
	}
	
    public function delete($productId)
	{
		return $this->getDbTable()->delete('product_id = '.$productId);
	}
	
	public function deletePartner($partnerId)
	{
		return $this->getDbTable()->delete('product_partner_id = '.$partnerId);
	}

	public function find($id, Application_Model_ProductPartners $partner)
	{
		$result = $this->getDbTable()->find($id);
		if (0 == count($result)) {
			return false;
		}
		$row = $result->current();
		
		$partner->setId($row->id)
		->setProductId($row->product_id)
		->setProductPartnerId($row->product_partner_id);

	}
	
	public function fetchAll()
	{
	    $select = $this->getDbTable()->select()
	    ->order('id desc');
	    $resultSet = $this->getDbTable()->fetchAll($select);
		$entries   = array();
		foreach ($resultSet as $row) {
			$entry = new Application_Model_ProductPartners();
			$entry->setId($row->id)
			->setProductId($row->product_id)
			->setProductPartnerId($row->product_partner_id);
			$entries[] = $entry;
		}
		return $entries;
	}
	
	public function fetchByProduct($productId, $type)
	{
		$select = $this->getDbTable()->select()
		->from(array('p' => 'product_partners',array('*')))
		->setIntegrityCheck(false)
		->join(array('pp' => 'product_partner'),
                    'pp.id = p.product_partner_id')
		->where('p.product_id= ?', $productId)
		->where('pp.type = ?', $type)
		->order('pp.id desc');

		$resultSet = $this->getDbTable()->fetchAll($select);
		$entries   = array();
		foreach ($resultSet as $row) {
			$entry = new Application_Model_ProductPartners();
			$entry->setId($row->id)
			->setProductId($row->product_id)
			->setProductPartnerId($row->product_partner_id);
			$entries[] = $entry;
		}
		return $entries;
	}
	
}