<?php

 
class Application_Model_ProductRegisterUser
{
	protected $_id;
	protected $_productRegisterId;
	protected $_firstname;
	protected $_lastname;
	protected $_position;
	protected $_email;
	protected $_tel;
	protected $_session;
	protected $_accredited;

    public function __construct(array $options = null)
    {
        if (is_array($options)) {
            $this->setOptions($options);
        }
    }
 
    public function __set($name, $value)
    {
        $method = 'set' . $name;
        if (('mapper' == $name) || !method_exists($this, $method)) {
            throw new Exception('Invalid page property');
        }
        $this->$method($value);
    }
 
    public function __get($name)
    {
        $method = 'get' . $name;
        if (('mapper' == $name) || !method_exists($this, $method)) {
            throw new Exception('Invalid page property');
        }
        return $this->$method();
    }
 
    public function setOptions(array $options)
    {
        $methods = get_class_methods($this);
        foreach ($options as $key => $value) {
            $method = 'set' . ucfirst($key);
            if (in_array($method, $methods)) {
                $this->$method($value);
            }
        }
        return $this;
    }
    
    public function getOptions()
    {
        $vars = get_class_vars('Application_Model_ProductRegisterUser');
        $data = array();
        foreach ($vars as $key => $value) {
           $data[ltrim($key,'_')] = $this->$key;
        }
       
        return $data;
    }
 
    public function setFirstname($firstname)
    {
        $this->_firstname = $firstname;
        return $this;
    }
 
    public function getFirstname()
    {
        return $this->_firstname;
    }
    
    public function setLastname($lastname)
    {
    	$this->_lastname = $lastname;
    	return $this;
    }
    
    public function getLastname()
    {
    	return $this->_lastname;
    }
    
    public function setPosition($position)
    {
    	$this->_position = $position;
    	return $this;
    }
    
    public function getPosition()
    {
    	return $this->_position;
    }
    
    public function setTel($tel)
    {
    	$this->_tel = $tel;
    	return $this;
    }
    
    public function getTel()
    {
    	return $this->_tel;
    }
    
    
    public function setEmail($email)
    {
    	$this->_email = $email;
    	return $this;
    }
    
    public function getEmail()
    {
    	return $this->_email;
    }
 
    public function setId($id)
    {
        $this->_id = (int) $id;
        return $this;
    }
 
    public function getId()
    {
        return $this->_id;
    }
    
    public function setProductRegisterId($id)
    {
    	$this->_productRegisterId = (int) $id;
    	return $this;
    }
    
    public function getProductRegisterId()
    {
    	return $this->_productRegisterId;
    }
    
    public function setSession($session)
    {
    	$this->_session = $session;
    	return $this;
    }
    
    public function getSession()
    {
    	return $this->_session;
    }
    
    public function setAccredited($accredited)
    {
    	$this->_accredited = $accredited;
    	return $this;
    }
    
    public function getAccredited()
    {
    	return $this->_accredited;
    }
    
}