<?php

 
class Application_Model_ProductRegisterUserSession
{
	protected $_id;
	protected $_productRegisterUserId;
	protected $_session;

    public function __construct(array $options = null)
    {
        if (is_array($options)) {
            $this->setOptions($options);
        }
    }
 
    public function __set($name, $value)
    {
        $method = 'set' . $name;
        if (('mapper' == $name) || !method_exists($this, $method)) {
            throw new Exception('Invalid page property');
        }
        $this->$method($value);
    }
 
    public function __get($name)
    {
        $method = 'get' . $name;
        if (('mapper' == $name) || !method_exists($this, $method)) {
            throw new Exception('Invalid page property');
        }
        return $this->$method();
    }
 
    public function setOptions(array $options)
    {
        $methods = get_class_methods($this);
        foreach ($options as $key => $value) {
            $method = 'set' . ucfirst($key);
            if (in_array($method, $methods)) {
                $this->$method($value);
            }
        }
        return $this;
    }
    
    public function getOptions()
    {
        $vars = get_class_vars('Application_Model_ProductRegisterUserSession');
        $data = array();
        foreach ($vars as $key => $value) {
           $data[ltrim($key,'_')] = $this->$key;
        }
       
        return $data;
    }
 

    public function setId($id)
    {
        $this->_id = (int) $id;
        return $this;
    }
 
    public function getId()
    {
        return $this->_id;
    }
    
    public function setProductRegisterUserId($id)
    {
    	$this->_productRegisterUserId = (int) $id;
    	return $this;
    }
    
    public function getProductRegisterUserId()
    {
    	return $this->_productRegisterUserId;
    }
    
    public function setSession($session)
    {
    	$this->_session = $session;
    	return $this;
    }
    
    public function getSession()
    {
    	return $this->_session;
    } 
}