<?php

 
class Application_Model_ProductSpeaker
{
	protected $_id;
	protected $_productId;
	protected $_active;
	protected $_title;
	protected $_function;
    protected $_logo;
    protected $_www;
    protected $_desc;
    protected $_type;

    public function __construct(array $options = null)
    {
        if (is_array($options)) {
            $this->setOptions($options);
        }
    }
 
    public function __set($name, $value)
    {
        $method = 'set' . $name;
        if (('mapper' == $name) || !method_exists($this, $method)) {
            throw new Exception('Invalid page property');
        }
        $this->$method($value);
    }
 
    public function __get($name)
    {
        $method = 'get' . $name;
        if (('mapper' == $name) || !method_exists($this, $method)) {
            throw new Exception('Invalid page property');
        }
        return $this->$method();
    }
 
    public function setOptions(array $options)
    {
        $methods = get_class_methods($this);
        foreach ($options as $key => $value) {
            $method = 'set' . ucfirst($key);
            if (in_array($method, $methods)) {
                $this->$method($value);
            }
        }
        return $this;
    }
    
    public function getOptions()
    {
        $vars = get_class_vars('Application_Model_ProductPartner');
        $data = array();
        foreach ($vars as $key => $value) {
           $data[ltrim($key,'_')] = $this->$key;
        }
       
        return $data;
    }
    
    public function setProductId($productId)
    {
    	$this->_productId = $productId ;
    	return $this;
    }
    
    public function getProductId()
    {
    	return $this->_productId;
    }
    
    public function setActive($active)
    {
    	$this->_active = $active;
    	return $this;
    }
    
    public function getActive()
    {
    	return $this->_active;
    }
    
 
    public function setTitle($title)
    {
        $this->_title = (string)$title;
        return $this;
    }
 
    public function getTitle()
    {
        return $this->_title;
    }
    
    public function setFunction($title)
    {
    	$this->_function = (string)$title;
    	return $this;
    }
    
    public function getFunction()
    {
    	return $this->_function;
    }
 
    public function setLogo($image)
    {
        $this->_logo = (string) $image;
        return $this;
    }
 
    public function getLogo()
    {
        return $this->_logo;
    }
    
    public function setWww($link)
    {
        $this->_www = (string) $link;
        return $this;
    }
 
    public function getWww()
    {
        return $this->_www;
    }
 
    
    public function setDesc($desc)
    {
        $this->_desc = (string)$desc;
        return $this;
    }
 
    public function getDesc()
    {
        return $this->_desc;
    }
    
    public function setType($type)
    {
    	$this->_type = $type;
    	return $this;
    }
    
    public function getType()
    {
    	return $this->_type;
    }
    
    
    public function setId($id)
    {
        $this->_id = (int) $id;
        return $this;
    }
 
    public function getId()
    {
        return $this->_id;
    }
}