<?php

 
class Application_Model_ProductType
{
	protected $_id;
	protected $_name;
	protected $_class;
	protected $_show;
    

    public function __construct(array $options = null)
    {
        if (is_array($options)) {
            $this->setOptions($options);
        }
    }
 
    public function __set($name, $value)
    {
        $method = 'set' . $name;
        if (('mapper' == $name) || !method_exists($this, $method)) {
            throw new Exception('Invalid page property');
        }
        $this->$method($value);
    }
 
    public function __get($name)
    {
        $method = 'get' . $name;
        if (('mapper' == $name) || !method_exists($this, $method)) {
            throw new Exception('Invalid page property');
        }
        return $this->$method();
    }
 
    public function setOptions(array $options)
    {
        $methods = get_class_methods($this);
        foreach ($options as $key => $value) {
            $method = 'set' . ucfirst($key);
            if (in_array($method, $methods)) {
                $this->$method($value);
            }
        }
        return $this;
    }
    
    public function getOptions()
    {
    	$vars = get_class_vars('Application_Model_ProductType');
    	$data = array();
    	foreach ($vars as $key => $value) {
    		$data[ltrim($key,'_')] = $this->$key;
    	}
    	 
    	return $data;
    }
 
    public function setName($name)
    {
        $this->_name = (string) $name;
        return $this;
    }
 
    public function getName()
    {
        return $this->_name;
    }
    
    public function setClass($class)
    {
    	$this->_class = (string) $class;
    	return $this;
    }
    
    public function getClass()
    {
    	return $this->_class;
    }
    
    public function setShow($show)
    {
    	$this->_show = (string) $show;
    	return $this;
    }
    
    public function getShow()
    {
    	return $this->_show;
    }
    
    
    public function getSlug()
    {
        return str_replace(" ", "-", $this->_name);
    }
 
    public function setId($id)
    {
        $this->_id = (int) $id;
        return $this;
    }
 
    public function getId()
    {
        return $this->_id;
    }
}