<?php
class Application_Model_ProductTypeMapper
{
	protected $_dbTable;

	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}

	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('Application_Model_DbTable_ProductType');
		}
		return $this->_dbTable;
	}

	public function find($id, Application_Model_ProductType $productType)
	{
		$result = $this->getDbTable()->find($id);
		if (0 == count($result)) {
			return false;
		}
		$row = $result->current();
		$productType->setId($row->id)
		->setName($row->name)
		->setClass($row->class)
		->setShow($row->show);;
		
		return true;
		
		
	}
	
	public function fetchAll()
	{
	    $select = $this->getDbTable()->select()
	    ->where('`show` = ?', 'Y')
	    ->order('id asc');

	    $resultSet = $this->getDbTable()->fetchAll($select);
		$entries   = array();
		foreach ($resultSet as $row) {
			$entry = new Application_Model_ProductType();
			$entry->setId($row->id)
		    ->setName($row->name)
			->setClass($row->class)
			->setShow($row->show);
			$entries[] = $entry;
		}
		return $entries;
	}
	
    public function fetchBySlug($slug)
	{
	    $select = $this->getDbTable()->select()
	    ->where('name = ?', str_replace("-", " ", $slug) );
	    $row = $this->getDbTable()->fetchRow($select);
	    if($row)
	    {
    		$entry = new Application_Model_ProductType();
    		$entry->setId($row->id)
    	    ->setName($row->name)
    		->setClass($row->class)->setClass($row->class)
			->setShow($row->show);
    	    return $entry;
	    }
	    return false;
		
		
	}
}