<?php

 
class Application_Model_Static
{
	protected $_id;
	protected $_description1;
	protected $_description2;


    public function __construct(array $options = null)
    {
        if (is_array($options)) {
            $this->setOptions($options);
        }
    }
 
    public function __set($name, $value)
    {
        $method = 'set' . $name;
        if (('mapper' == $name) || !method_exists($this, $method)) {
            throw new Exception('Invalid page property');
        }
        $this->$method($value);
    }
 
    public function __get($name)
    {
        $method = 'get' . $name;
        if (('mapper' == $name) || !method_exists($this, $method)) {
            throw new Exception('Invalid page property');
        }
        return $this->$method();
    }
 
    public function setOptions(array $options)
    {
        $methods = get_class_methods($this);
        foreach ($options as $key => $value) {
            $method = 'set' . ucfirst($key);
            if (in_array($method, $methods)) {
                $this->$method($value);
            }
        }
        return $this;
    }
    
    public function getOptions()
    {
        $vars = get_class_vars('Application_Model_Static');
        $data = array();
        foreach ($vars as $key => $value) {
           $data[ltrim($key,'_')] = $this->$key;
        }
       
        return $data;
    }
 
 	public function setDescription1($txt)
    {
    	$this->_description1 = (string) $txt;
    	return $this;
    }
    
    public function getDescription1()
    {
    	return $this->_description1;
    }
    
    public function setDescription2($txt)
    {
    	$this->_description2 = (string) $txt;
    	return $this;
    }
    
    public function getDescription2()
    {
    	return $this->_description2;
    }
 
    
    public function setId($id)
    {
        $this->_id = (int) $id;
        return $this;
    }
 
    public function getId()
    {
        return $this->_id;
    }
}