<?php
class Application_Model_StaticMapper
{
	protected $_dbTable;

	public function setDbTable($dbTable)
	{
		if (is_string($dbTable)) {
			$dbTable = new $dbTable();
		}
		if (!$dbTable instanceof Zend_Db_Table_Abstract) {
			throw new Exception('Invalid table data gateway provided');
		}
		$this->_dbTable = $dbTable;
		return $this;
	}

	public function getDbTable()
	{
		if (null === $this->_dbTable) {
			$this->setDbTable('Application_Model_DbTable_Static');
		}
		return $this->_dbTable;
	}

	public function save(Application_Model_Static $static)
	{
		$data = array(
			'description1' => $static->getDescription1(),
			'description2' => $static->getDescription2(),

		);

		if (null === ($id = $static->getId())) {
			unset($data['id']);
			return $this->getDbTable()->insert($data);
		} else {
			return $this->getDbTable()->update($data, array('id = ?' => $id));
		}
	}
	


	public function find($id, Application_Model_Static $static)
	{
		$result = $this->getDbTable()->find($id);
		if (0 == count($result)) {
			return false;
		}
		
		$row = $result->current();
		
		$static->setId($row->id)
		->setDescription1($row->description1)
		->setDescription2($row->description2);

	}
	
	public function fetchAll($options = array())
	{
		$select = $this->getDbTable()->select();
		 
	
		$select->order('id asc');
		 
		if(isset($options['search']))
		{
			$select->where('(description1 LIKE "%'.$options['search'].'%"')
			->orWhere('description2 LIKE "%'.$options['search'].'%")');
	
		}
		$resultSet = $this->getDbTable()->fetchAll($select);
		
		$entries   = array();
		foreach ($resultSet as $row) {
			$static = new Application_Model_Static();
				
			$static->setId($row->id)
			->setDescription1($row->description1)
			->setDescription2($row->description2);
	
			$entries[] = $static;
		}
		return $entries;
	}
	
}